/////////////////////////////////////////////////////////////
/// By Michael Gibson
/// (c)2003-2007 
/// Code under GPL
/// Part of the Gibson's GEDXchange GEDCOM Tools
/// Converts stop9 format to GEDCOM
//////////////////////////////////////////////////////////////
#include <stdio.h>
#include <string.h>

char *r_version="0.8.5";

void read_data(void);
void write_i_data(void);
void write_f_data(void);
void write_c_data(void);

char start_r[5];
char end_r[5];
char idnum[500][99];
char firstname[500][99];
char middlename[500][99];
char surname[500][99];
char sex[500][99];
char birth_date[500][99];
char birth_place[500][99];
char birth_note[500][154];
char death_date[500][99];
char death_place[500][99];
char death_note[500][154];
char burial_place[500][99];
char burial_note[500][154];
char occupation[500][99];
char education[500][99];
char religon[500][99];
char gen_note[500][154];
char t_father[500][99];
char t_mother[500][99];
char t_spouce[500][99];

int num_of_entries;
char filename[50];

int stop9;

int main(int argc, char **argv)
{

  if(argc==2){
    sprintf(filename,"%s",argv[1]);
    printf("%s = filename\n",filename);
  }
  else{
    sprintf(filename,"temp.ged");
    printf("%s = filename\n",filename);
  }

  read_data();
  write_i_data();
  write_f_data();
  write_c_data();
  return(0);
}

/////////////////////////////
/// read data
/////////////////////////////
void read_data()
{
  int x=0;
  FILE *filedatap;

  filedatap=fopen("idata.gsf","r");
  printf("Input file opened....\n\n");
  do{
    x++;
    if(x==999) start_r[2] = 'F';
    fgets(start_r,9,filedatap);
    if(start_r[2]== 'F') break;
    fgets(idnum[x],54,filedatap);
    fgets(firstname[x],54,filedatap);
    fgets(middlename[x],54,filedatap);
    fgets(surname[x],54,filedatap);
    fgets(sex[x],54,filedatap);
    fgets(birth_date[x],54,filedatap);
    fgets(birth_place[x],94,filedatap);
    fgets(birth_note[x],154,filedatap);
    fgets(death_date[x],54,filedatap);
    fgets(death_place[x],94,filedatap);
    fgets(death_note[x],154,filedatap);
    fgets(burial_place[x],94,filedatap);
    fgets(burial_note[x],154,filedatap);
    fgets(education[x],94,filedatap);
    fgets(occupation[x],94,filedatap);
    fgets(religon[x],94,filedatap);
    fgets(gen_note[x],154,filedatap);
    fgets(t_father[x],20,filedatap);
    fgets(t_mother[x],20,filedatap);
    fgets(t_spouce[x],20,filedatap);
    fgets(end_r,9,filedatap);
  //012
  //EOF
    printf("%s |%s |%s |%s\n",idnum[x],firstname[x], middlename[x],surname[x]);
  }while(start_r[2] != 'F' );
  x=x-1;
  printf("\nInput file read....\nNumber of individuals read =%d\n",x);
  num_of_entries=x;
  fclose(filedatap);
  printf("Input file closed...\n");
  stop9=x;
}

/////////////////////////
/// write individual data
////////////////////////
void write_i_data()
{
  int x;
  int loop;

  FILE *fp;
  
  fp=fopen(filename,"w+");

/// Heading
  fprintf(fp,"0 HEAD\n");
  fprintf(fp,"1 SOUR MRGIBSON.COM\n");
  fprintf(fp,"2 NAME Convert9\n");
  fprintf(fp,"2 VERS %s\n",r_version);
  fprintf(fp,"1 DEST ANSTFILE\n");
  fprintf(fp,"1 CHAR ANSI\n");
  fprintf(fp,"1 FILE %s\n",filename);
  fprintf(fp,"1 GEDC\n");
  fprintf(fp,"2 VERS 5.5\n");
  fprintf(fp,"2 FORM LINEAGE-LINKED\n");

  printf("\n\nGEDCOM Heading written....\n\n");

/// Individual 
  for(x=1;x<= num_of_entries;x++){

     for(loop=0;loop<=99;loop++){
        if(idnum[x][loop]=='\n')        idnum[x][loop]='\0';
        if(firstname[x][loop]=='\n')    firstname[x][loop]='\0';
        if(middlename[x][loop]=='\n')   middlename[x][loop]='\0';
        if(surname[x][loop]=='\n')      surname[x][loop]='\0';
        if(birth_date[x][loop]=='\n')   birth_date[x][loop]='\0';
        if(birth_place[x][loop]=='\n')  birth_place[x][loop]='\0';
        if(birth_note[x][loop]=='\n')   birth_note[x][loop]='\0';
        if(death_date[x][loop]=='\n')   death_date[x][loop]='\0';
        if(death_place[x][loop]=='\n')  death_place[x][loop]='\0';
        if(death_note[x][loop]=='\n')   death_note[x][loop]='\0';
        if(burial_place[x][loop]=='\n') burial_place[x][loop]='\0';
        if(burial_note[x][loop]=='\n')  burial_note[x][loop]='\0';
        if(education[x][loop]=='\n')    education[x][loop]='\0';
        if(occupation[x][loop]=='\n')   occupation[x][loop]='\0';
        if(religon[x][loop]=='\n')      religon[x][loop]='\0'; 
        if(gen_note[x][loop]=='\n')     gen_note[x][loop]='\0';
        if(t_father[x][loop]=='\n')     t_father[x][loop]='\0';
        if(t_mother[x][loop]=='\n')     t_mother[x][loop]='\0';
        if(t_spouce[x][loop]=='\n')     t_spouce[x][loop]='\0';
      }

     for(loop=4;loop<=99;loop++){
        idnum[x][loop-4]=idnum[x][loop];
        firstname[x][loop-4]=firstname[x][loop];
        middlename[x][loop-4]=middlename[x][loop];
        sex[x][loop-4]=sex[x][loop];
        surname[x][loop-4]=surname[x][loop];
        birth_date[x][loop-4]=birth_date[x][loop];
        birth_place[x][loop-4]=birth_place[x][loop];
        birth_note[x][loop-4]=birth_note[x][loop];
        death_date[x][loop-4]=death_date[x][loop];
        death_place[x][loop-4]=death_place[x][loop];
        death_note[x][loop-4]=death_note[x][loop];
        burial_place[x][loop-4]=burial_place[x][loop];
        burial_note[x][loop-4]=burial_note[x][loop];
        education[x][loop-4]=education[x][loop];
        occupation[x][loop-4]=occupation[x][loop];
        religon[x][loop-4]=religon[x][loop];
        gen_note[x][loop-4]=gen_note[x][loop];
        t_father[x][loop-4]=t_father[x][loop];
        t_mother[x][loop-4]=t_mother[x][loop];
        t_spouce[x][loop-4]=t_spouce[x][loop];
      }


     for(loop=0;loop<=99;loop++){
        if(idnum[x][loop]==' ') idnum[x][loop]='\0';
        if(t_father[x][loop]==' ') t_father[x][loop]='\0';
        if(t_mother[x][loop]==' ') t_mother[x][loop]='\0';
        if(t_spouce[x][loop]==' ') t_spouce[x][loop]='\0';
      }


    if(surname[x][0]!= '-' ){
      fprintf(fp,"0 @I%s@ INDI\n",idnum[x]);
      fprintf(fp,"1 NAME %s %s /%s/\n",firstname[x],middlename[x],surname[x]);
      fprintf(fp,"1 SEX %c\n",sex[x][0]);
      fprintf(fp,"1 BIRT\n");
      if(birth_date[x][0]!='-'){
        fprintf(fp,"2 DATE %s\n",birth_date[x]);
      }
      if(birth_place[x][0]!='-'){
        fprintf(fp,"2 PLAC %s\n",birth_place[x]);
      }
      if(birth_note[x][0]!='-'){
        fprintf(fp,"2 NOTE %s\n",birth_note[x]);
      }
      if(death_date[x][0]!='-'){
        fprintf(fp,"1 DEAT\n");
      }
      if(death_date[x][0]!='-'){
        fprintf(fp,"2 DATE %s\n",death_date[x]);
      }
      if(death_place[x][0]!='-'){
        fprintf(fp,"2 PLAC %s\n",death_place[x]);
      }
      if(death_note[x][0]!='-'){
        fprintf(fp,"2 NOTE %s\n",death_note[x]);
      }
      if(burial_place[x][0]!='-'){
        fprintf(fp,"1 BURI\n");
      }
      if(burial_place[x][0]!='-'){
        fprintf(fp,"1 PLAC %s\n",burial_place[x]);
      }
      if(burial_note[x][0]!='-'){
        fprintf(fp,"1 PLAC %s\n",burial_note[x]);
      }

      if(education[x][0]!='-'){
        fprintf(fp,"1 EDUC %s\n",education[x]);
      }
      if(occupation[x][0]!='-'){
        fprintf(fp,"1 OCCU %s\n",occupation[x]);
      }
      if(religon[x][0]!='-'){
        fprintf(fp,"1 RELI %s\n",religon[x]);
      }

      if(gen_note[x][0]!='-'){
        fprintf(fp,"1 note %s\n",gen_note[x]);
      }
  fprintf(fp,"1 FAMC @F%04d@\n",x);

      for(loop=1;loop<=stop9;loop++){
        if(atoi(idnum[x])==atoi(t_father[loop])){
              fprintf(fp,"1 FAMS @F%04d@\n",loop);
          }
      }
      for(loop=1;loop<=stop9;loop++){
        if(atoi(idnum[x])==atoi(t_mother[loop])){
           fprintf(fp,"1 FAMS @F%04d@\n",loop);
        }
      }
    }
  }

  fclose(fp);
  printf("done writing individuals\n");
}                                                                                                                             
////////////////////////////////////
/// family format
///////////////////////////////////
void write_f_data()
{

  FILE *fp;
  int x=0;

  fp=fopen(filename,"a");

  do{
    x++;
    fprintf(fp,"0 @F%04d@ FAM\n",x);
    if(t_father[x][0] != '\0') fprintf(fp,"1 HUSB @I%s@\n",t_father[x]);
    if(t_mother[x][0] != '\0') fprintf(fp,"1 WIFE @I%s@\n",t_mother[x]);
    if(idnum[x][0] != '\0') fprintf(fp,"1 CHIL @I%s@\n",idnum[x]);
  }while(x<=stop9);

  fclose(fp);

}

/////////////////////////
/// write close data
////////////////////////
void write_c_data()
{
                                                                                                                             
  FILE *fp;
                                                                                                                             
  fp=fopen(filename,"a");
                                                                                                                             
/// Close 
  fprintf(fp,"0 TRLR\n");

  fclose(fp);
}
